﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Warmly_Lokomotive_Base
{
    public partial class FormLokomotive : Form
    {
        public FormLokomotive()
        {
            InitializeComponent();
        }

        private DrawingLokomotive  _locomotive;
        private void Draw()
        {
            Bitmap bmp = new(pictureBox1.Width, pictureBox1.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _locomotive?.DrawTransport(gr);
            pictureBox1.Image = bmp;
        }
        private void button1_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            _locomotive = new DrawingLokomotive();
            _locomotive.Init(rnd.Next(100, 300), rnd.Next(1000, 2000), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)));
            _locomotive.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBox1.Width, pictureBox1.Height);
            toolStripStatusLabelSpeed.Text = $"Скорость: {_locomotive.Locomotive.Speed}";
            toolStripStatusLabelWeight.Text = $"Вес: {_locomotive.Locomotive.Weight}";
            toolStripStatusLabelColor.Text = $"Цвет: {_locomotive.Locomotive.BodyColor.Name}";
            Draw();
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
        }
        private void ButtonMove_click(object sender, EventArgs e)
        {
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _locomotive?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _locomotive?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _locomotive?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _locomotive?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }

        private void statusStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
        }
        private void pictureBox1_Resize(object sender, EventArgs e)
        {
            _locomotive?.ChangeBorders(pictureBox1.Width, pictureBox1.Height);
            Draw();
        }
    }
}
